Library ClipperStuff;

uses
  Windows, SysUtils,
  keys, plugin;

type
  TMessageNumber = (
    MOK,
    MCancel,
    MNotPrg,             //  PRG 
    MError,              // 
    MWarning,            // 
    MPluginName,         //  
    MNoblockSelected,    //   
    MNoProc,             //     

    MFormat,            // 
    MFuncList,          //  
    MCommentBlock,      //  
    MUnCommentBlock,    //  
    MCommentEndOfLines, //   
    MConfig,            // 

    MConfigTitle,
    MGlobalTab,
    MMainTab,
    MFuncTab,
    MTextFuncTab,
    MTab,
    MComments,
    MNextStringTab
  );
  TInitDialogItem = packed record
    ItemType: integer;
    X1, Y1, X2, Y2: integer;
    Focus: integer;
    Selected: integer;
    Flags: DWORD;
    DefaultButton: integer;
    Data: PChar;
  end;
  TInitDialogItemArr = packed array [0..Pred(MaxInt div SizeOf(TInitDialogItem))] of TInitDialogItem;
  PInitDialogItemArr = ^TInitDialogItemArr;
Const
  mas3plus: Array[1..5] Of String = ('IF', 'FOR', 'IF.', 'DO WHILE', 'WHILE');

Var
  budet: TEditorSetString;
  was: TEditorGetString;
  sp: TEditorSetPosition;
  inden, indennext: Integer;
  atab: Integer;
  clipmas: Array Of String[13];
  key_before: Array Of String[11];
  key_after: Array Of String[13];
  audi: Integer;
  Kozlovam: Integer;
  is_block: Boolean;
  h: Integer;
  kol_lines: Integer;
  beg_line_block: Integer;
  ei: TEditorInfo;
  tek_path: String;
  Info: TPluginStartupInfo;
  PluginStrings: Array[0..0] Of pChar;
  comments, tcns, globaltab: Integer;
  MAINTAB, TEXTFUNCTAB, FUNCTAB: Integer;

function GetMsg(MsgId: TMessageNumber): PChar;
begin
  with Info do Result := GetMsg(ModuleNumber, Integer(MsgId));
end;

function Message(Flags: DWORD; HelpTopic: PChar; AItems: array of const; ButtonsNumber: Integer): Integer;
var
  Items: PPCharArr;
  ItemsNumber: Integer;
  I: Integer;
begin
  ItemsNumber := High(AItems)+1;
  GetMem(Items, SizeOf(PChar)*ItemsNumber);

  for I := 0 to High(AItems) do
    with AItems[I] do
      case VType of
        vtInteger: Items^[I] := GetMsg(TMessageNumber(VInteger));
        vtPChar: Items^[I] := VPChar;
        vtAnsiString: Items^[I] := VAnsiString;
        else Items^[I] := ' ';
      end;
  with Info do
    Result := Message(ModuleNumber,
      Flags,
      HelpTopic,
      Items,
      ItemsNumber,
      ButtonsNumber);

  FreeMem(Items);
end;

procedure InitDialogItems(Init: PInitDialogItemArr; Item: PFarDialogItemArr;
                          ItemsNumber: integer);
var
  i: integer;
begin
  for i:=0 to ItemsNumber-1 do
  begin
    Item^[I].ItemType:=Init^[I].ItemType;
    Item^[I].X1:=Init^[I].X1;
    Item^[I].Y1:=Init^[I].Y1;
    Item^[I].X2:=Init^[I].X2;
    Item^[I].Y2:=Init^[I].Y2;
    Item^[I].Focus:=Init^[I].Focus;
    Item^[I].Selected:=Init^[I].Selected;
    Item^[I].Flags:=Init^[I].Flags;
    Item^[I].DefaultButton:=Init^[I].DefaultButton;
    if (cardinal(Init^[I].Data)<2000) then
      StrCopy(Item^[I].Data, GetMsg(TMessageNumber(Init^[I].Data)))
    else
      StrCopy(Item^[I].Data, Init^[I].Data);
  end;
end;

Function IsAlpha(a1: Char): Boolean;
Begin
  Result:=((Ord(a1)>64)And(Ord(a1)<91)) Or ((Ord(a1)>96)And(Ord(a1)<123));
End;

Function min(a9, b9: Integer): Integer;
Begin
  If a9 > b9 Then Result := b9
  Else Result := a9;
End;

Function repl(a1: Char; a2: Integer): String;
Var a: String;
    t: Integer;
Begin
//  FillChar(a, a2, ord(a1));
  a := '';
  For t := 1 To a2 Do a := a + a1;
  repl := a;
End;

Procedure SetString(n1: Integer; str2: String);
Begin
  budet.StringNumber := n1;
  budet.StringText := pChar(str2);
  budet.StringEOL := pChar(#13#10);
  budet.StringLength := Length(str2);
  Info.EditorControl(ECTL_SETSTRING, @budet);
End;

Function get_str(nomrow: Integer): String;
Begin
  sp.CurLine := nomrow;
  Info.EditorControl(ECTL_SETPOSITION, @sp);
  Info.EditorControl(ECTL_GETSTRING, @was);
  Result := was.stringtext;
End;

Function Coolfunc(mystr2: String): String;
//       
// substr -> SubStr
Var
  hms, hms1, midl: Integer;
  strrezult: String;
  mystr1: String;
  flagnotexit: Boolean;
Begin
  mystr1 := AnsiUpperCase(mystr2);
  flagnotexit := True;
  For hms := 0 To Kozlovam-1 Do
    If mystr1 = key_before[hms] Then Begin
      strrezult := key_after[hms];
      flagnotexit := False;
    End;
  If flagnotexit Then Begin
    hms := 0;
    hms1 := audi;
    midl := 0;
    While (mystr1 <> AnsiUpperCase(clipmas[midl])) And ((hms1 - hms) > 1) Do Begin
      midl := Round(hms + (hms1 - hms) / 2);
      If mystr1 < AnsiUpperCase(clipmas[midl]) Then hms1 := midl
      Else hms := midl;
    End;
    If AnsiUpperCase(clipmas[midl]) = mystr1 Then strrezult := clipmas[midl]
    Else Begin
      hms := 0;
      hms1 := audi;
      While (mystr1 <> AnsiUpperCase(Copy(clipmas[midl], 1, 4))) And ((hms1 - hms) > 1) Do Begin
        midl := Round(hms + (hms1 - hms) / 2);
        If mystr1 < AnsiUpperCase(Copy(clipmas[midl], 1, 4)) Then hms1 := midl
        Else hms := midl;
      End;
      If AnsiUpperCase(Copy(clipmas[midl], 1, 4)) = mystr1 Then
        strrezult := Copy(clipmas[midl], 1, 4)
      Else strrezult := mystr2;
    End;
  End;
  Result := strrezult;
End;

//////////////////////////////////////////////////////////////////////////

Procedure Deleteline; //  
Var str1: String;
Begin
  If is_block Then h := beg_line_block
  Else h := 0;
  While h <= kol_lines Do Begin
    str1 := AnsiUpperCase(TrimLeft(get_str(h)));
    If is_block Then Begin
      If ((WAS.SelStart = was.SelEnd) Or (was.SelStart = -1)) Then
        Break;
    End;
    If Length(str1) = 0 Then Begin
      Info.EditorControl(ECTL_DELETESTRING, Nil);
      dec(h);
      dec(kol_lines);
      if h <= ei.CurLine then begin
        Dec(ei.CurLine);
        Dec(ei.TopScreenLine);
      end;
    End;
    str1 := AnsiUpperCase(TrimLeft(was.stringtext));
    If (Copy(str1, 1, 5) = 'PROC ') Or (Copy(str1, 1, 10) = 'PROCEDURE ') Or
      (Copy(str1, 1, 5) = 'FUNC ') Or (Copy(str1, 1, 9) = 'FUNCTION ') Then Begin
      sp.curpos := 0;
      Info.EditorControl(ECTL_SETPOSITION, @sp);
      Info.EditorControl(ECTL_INSERTSTRING, Nil);
      Inc(h);
      Inc(kol_lines);
      if h <= ei.CurLine then begin
        Inc(ei.CurLine);
        Inc(ei.TopScreenLine);
      end;
    End;
    Inc(h);
  End;
End;

Procedure Capitalization;
Var zupstr, str1: String;
  t: Integer;
  maskluch: Array Of String;
  maskluch_pos: Array Of Integer;
  kolkluch: Integer;
  bword: String;
  fl_comment, fl_comment_big, GoodWord: Boolean;
  flagnextstring: Boolean;
  temp1, pui1: Integer;
  v1, v2: Char;
  fl_str34 {"}, fl_str39 {'}: Boolean;
  opernext: Boolean;
  tempmy: Integer;
  flagnextplus: Boolean;
  tempDF4, tempDF3, tempDF1, tempDF2: Integer;
  kolvotabnextstr: Integer;
  T1: String;
  tempflag: Boolean; //   ?
  supernext: Boolean;
  prodoljenie: Boolean;
  flagfunction: Boolean; //  'Procedure' or 'Function'
Begin
  fl_comment := False;
  fl_comment_big := False;
  fl_str34 := False;
  fl_str39 := False;
  GoodWord := False;
  flagnextplus := False;
  indennext := 0;
  kolvotabnextstr := 8;
  flagfunction := False;
  supernext := False;
  prodoljenie := False;

  If is_block Then inden := ei.CurPos
  Else inden := 0;

  If is_block Then h := beg_line_block
  Else h := 0;
  //   
  While h <= kol_lines Do Begin
    str1 := Trim{Left}(get_str(h));
    If is_block Then Begin
      If ((WAS.SelStart = was.SelEnd) Or (was.SelStart = -1)) Then
        Break;
    End;
    kolkluch := 0;
    zupstr := '';
    bWord := '';
    If Length(str1) > 0 Then
      If str1[1] = '*' Then fl_comment := True;
    flagnextstring := False;

    //   ( )
    For temp1 := 1 To Length(str1) Do Begin
      v2 := str1[temp1];
      V1 := UPCASE(v2);
      //   
      If (V1 = '&') Or (V1 = '/') Then
        If temp1 + 1 <= Length(str1) Then Begin  //    
          If (v1 = '&') And (str1[temp1 + 1] = '&') Then fl_comment := True;
          If (v1 = '/') Then Begin
            If (str1[temp1 + 1] = '/') Then fl_comment := True;
            If (str1[temp1 + 1] = '*') Then
              If Not (fl_comment) Then fl_comment_big := True;
          End;
        End;

      If fl_comment Then
        If (fl_str34) Or (fl_str39) Then Begin
          fl_comment := False; //   ,     !
          fl_comment_big := False;
        End;

      //      ?
      If (Not (fl_comment)) And (Not (fl_comment_big)) Then
        If (Not (fl_str34)) And (Not (fl_str39)) Then Begin
          If v2 = ';' Then flagnextstring := True;
          If (v2 <> ';') And (v2 <> #32) And (v2 <> #9) Then flagnextstring := False;
        End;

      //   A-Z,a-z,'_'
      If ((Ord(V1) > 64) And (Ord(V1) < 91)) Or ((Ord(V1) >= 48) And (Ord(V1) <= 57)) Or (V1 = #95 {_}) Then Begin
        bWord := bWord + v2;
        If temp1 = Length(str1) Then Begin // 
          If Length(bword) > 1 Then
            If (Not (fl_comment)) And (Not (fl_comment_big)) Then
              If (Not (fl_str34)) And (Not (fl_str39)) Then
                If IsAlpha(UpCase(bword[1])) Then Begin
                  GoodWord := True;
                End;
          If GoodWord Then Begin //    !
            GoodWord := False;
            Inc(kolkluch);
            SetLength(maskluch, kolkluch);
            SetLength(maskluch_pos, kolkluch);
            maskluch[kolkluch-1] := bword;
            maskluch_pos[kolkluch-1] := temp1 - Length(bword) + 1;
            zupstr := zupstr + CoolFunc(bword);
          End
          Else Begin
            zupstr := zupstr + bword;
          End;
          bWord := '';
        End; //temp1=length(str1)
      End
      Else Begin // 
        If Length(bword) > 1 Then
          If (Not (fl_comment)) And (Not (fl_comment_big)) Then
            If (Not (fl_str34)) And (Not (fl_str39)) Then
              If isalpha(upcase(bword[1])) Then Begin
                GoodWord := True;
              End;
        If GoodWord Then Begin //    !
          GoodWord := False;

          If UpperCase(bword) = 'WHILE' Then Begin //while    
            opernext := False;
            if (Not prodoljenie) then
              If (AnsiUpperCase(Copy(str1, 1, 2))='DO') or (temp1=6) Then
                opernext := True;
              For tempmy := temp1 - 1 - Length(bword) Downto 1 Do Begin
                If str1[tempmy] = ';' Then Begin
                  opernext := True;
                  Break;
                End
                Else If (str1[tempmy]<>#32) And (str1[tempmy]<>#9) Then Break;
              End;
            If Not opernext Then Dec(indennext, atab);
          End;

          If UpperCase(bword) = 'NEXT' Then Begin //Next     COPY TO
            opernext := False;
            If (temp1 = 5) And (Not prodoljenie) Then opernext := True;
            For tempmy := temp1 - 1 - Length(bword) Downto 1 Do Begin
              If str1[tempmy] = ';' Then Begin
                opernext := True;
                Break;
              End
              Else If (str1[tempmy]<>#32) And (str1[tempmy]<>#9) Then Break;
            End;
            If Not opernext Then Begin
              Inc(inden, atab);
              Inc(indennext, atab);
            End;
          End;

          If UpperCase(bword) = 'FOR' Then Begin //FOR     Locate
            //opernext -  -  FOR
            opernext := False;
            If (temp1 = 4) And (Not prodoljenie) Then opernext := True;
            For tempmy := temp1 - 1 - Length(bword) Downto 1 Do Begin
              If str1[tempmy] = ';' Then Begin
                opernext := True;
                Break;
              End
              Else If (str1[tempmy]<>#32) And (str1[tempmy]<>#9) Then Break;
            End;
            If Not opernext Then Dec(indennext, atab);
          End;
          Inc(kolkluch);
          SetLength(maskluch, kolkluch);
          SetLength(maskluch_pos, kolkluch);
          maskluch[kolkluch-1] := bword;
          maskluch_pos[kolkluch-1] := temp1 - Length(bword);
          zupstr := zupstr + CoolFunc(bword) + v2;
        End // if GoodWord
        Else zupstr := zupstr + bword + v2;
        bWord := '';
      End;

      If (V1 = '*') Then //  ?
        If temp1 + 1 <= Length(str1) Then
          If (str1[temp1 + 1] = '/') Then fl_comment_big := False;

      //   ?
      If (Not (fl_comment)) And (Not (fl_comment_big)) Then Begin
        //      
        If V1 = '"' Then
          If Not (fl_str39) Then
            fl_str34 := Not (fl_str34);
        If V1 = '''' {if v1=} Then
          If Not (fl_str34) Then
            fl_str39 := Not (fl_str39);
      End;
    End; //next_char

    If flagnextstring Then Begin
      If Not (flagnextplus) Then Begin
        //      - 
        If tcns = -1 Then Begin
          If str1[1] = '@' Then Begin
            If pos('SAY', AnsiUpperCase(str1)) <> 0 Then
              kolvotabnextstr := pos('SAY', AnsiUpperCase(str1)) + 3
            Else Begin
              If pos('GET', AnsiUpperCase(str1)) <> 0 Then
                kolvotabnextstr := pos('GET', AnsiUpperCase(str1)) + 3
              Else
                kolvotabnextstr := pos(' ', str1);
            End;
          End //     = '@'
          Else Begin
            tempDF1 := pos(' ', zupstr);
            tempDF2 := pos('(', zupstr);
            tempDF3 := pos('{', zupstr);
            tempDF4 := pos('=', zupstr);

            If tempDF1 = 0 Then tempDF1 := 999;
            If tempDF2 = 0 Then tempDF2 := 999;
            If tempDF3 = 0 Then tempDF3 := 999;
            If tempDF4 = 0 Then tempDF4 := 999;
            kolvotabnextstr := min(tempDF1, tempDF2);
            kolvotabnextstr := min(kolvotabnextstr, tempDF3);
            If (tempDF1 = 999) And (tempDF2 = 999) And (tempDF3 = 999) Then Begin
              If tempDF4 = 999 Then kolvotabnextstr := 5
              Else kolvotabnextstr := min(kolvotabnextstr, tempDF4);
            End;
          End //     <> '@'
        End // if tcns = -1
        Else kolvotabnextstr := tcns;

        Inc(indennext, kolvotabnextstr); //     
        flagnextplus := True;
      End; // if Not (flagnextplus)
    End // if flagnextstring
    Else Begin // if NOT flagnextstring
      If flagnextplus Then Begin
        dec(indennext, kolvotabnextstr);
        flagnextplus := False;
        If supernext Then Begin // IF     
          supernext := False;
          Inc(indennext, atab)
        End;
      End
    End; // if NOT flagnextstring

    //  - 
    For t := 0 To kolkluch-1 Do Begin
      t1 := UpperCase(maskluch[t]);
      If (t1 = 'ENDDO') Or (t1 = 'ENDD') Or (t1 = 'END') Or (t1 = 'ENDCASE') Or (t1 = 'ENDC') Or
        (t1 = 'ENDI') Or (t1 = 'ENDIF') Or (t1 = 'ELSE') Or (t1 = 'ELSEIF') Or (t1 = 'CASE') Or
        (t1 = 'OTHERWISE') Or (t1 = 'OTHE') Or (t1 = 'OTHER')
        Or (t1 = 'NEXT') Then dec(indennext, atab);

      If (t1 = 'ENDDO') Or (t1 = 'ENDD') Or (t1 = 'ENDCASE') Or (t1 = 'ENDC') Or (t1 = 'CASE') Or
        (t1 = 'ELSE') Or (t1 = 'ELSEIF') Or (t1 = 'OTHE') Or (t1 = 'OTHER') Or
        (t1 = 'ENDIF') Or (t1 = 'ENDI') Or (t1 = 'NEXT') Or (t1 = 'OTHERWISE') Then dec(inden, atab);

      If ((t1 = 'IF') And (maskluch_pos[t] = 1) And (Not (prodoljenie)))
        //(upper(copy(str1,1,2))='IF') and (not(prodoljenie)) or (not';if')
      Or (t1 = 'ELSE') Or (t1 = 'ELSEIF') Or (t1 = 'FOR') Or (t1 = 'CASE') Or (t1 = 'WHILE') Or
        (t1 = 'WHIL') Or (t1 = 'OTHE') Or (t1 = 'OTHERWISE') Or (t1 = 'OTHER') Then Begin
        If (Not flagnextstring) Then Inc(indennext, atab)
        Else supernext:=True;
      End;
    End;
    If AnsiUpperCase(Copy(zupstr, 1, 7)) = 'DO CASE' Then Begin
      Inc(indennext, atab);
      Inc(inden, atab);
    End;

    //    ?
    tempflag := False;
    If comments <> -1 Then Begin
      If Length(str1) > 0 Then
        If str1[1] = '*' Then tempflag := True;
      If Length(str1) > 1 Then
        If Copy(str1, 1, 2) = '//' Then tempflag := True;
      If fl_comment_big Then
        tempflag := True
    End;
    If tempflag Then pui1 := comments
    Else Begin
      If (AnsiUpperCase(Copy(str1, 1, 5)) = 'PROC ') Or (AnsiUpperCase(Copy(str1, 1, 10)) = 'PROCEDURE ')
        Or (AnsiUpperCase(Copy(str1, 1, 5)) = 'FUNC ')
        Or (AnsiUpperCase(Copy(str1, 1, 9)) = 'FUNCTION ') Then Begin
        pui1 := globaltab + functab;
        flagfunction := True;
        indennext:=0;
      End
      Else Begin
        If flagfunction Then pui1 := TextFuncTab + GlobalTab + inden
        Else Begin
          If Copy(str1, 1, 1) = '#' Then pui1 := globaltab + inden
          Else pui1 := globaltab + maintab + inden;
        End;
      End;
    End;
    //   
    setstring(h, Repl(' ', pui1) + zupstr);
    inden := indennext;
    Inc(h);
    fl_comment := False;
    prodoljenie := flagnextstring;
  End; //next_line

  Deleteline;
  ei.CurPos:=0; ei.CurTabPos:=0; ei.LeftPos:=0;
End;

//////////////////////////////////////////////////////////////////////////

Procedure CommentEndOperator;
Var t, stek: Integer;
  str1, str3: String;
  masstring: Array Of String;
Begin
  If is_block Then h := beg_line_block
  Else h := 0;
  stek := 0;
  While h <= kol_lines Do Begin
    str3 := get_str(h);
    str1 := AnsiUpperCase(TrimLeft(str3));
    If is_block Then Begin
      If ((WAS.SelStart = was.SelEnd) Or (was.SelStart = -1)) Then
        Break;
    End;

    For t := 1 To 5 Do
      If (Copy(str1, 1, Length(mas3plus[t])) = mas3plus[t]) And (Not (IsAlpha(str1[Length(mas3plus[t]) + 1]))) Then Begin
        SetLength(masstring, stek+1);
        masstring[stek]:= Copy(TrimLeft(was.stringtext), Length(mas3plus[t]) + 1,
                          Length(TrimLeft(was.stringtext)) - Length(mas3plus[t]));
        Inc(stek);
      End;
    If (Copy(str1, 1, 4) = 'NEXT') Or
       (Copy(str1, 1, 4) = 'ENDD') Or
       (Copy(str1, 1, 4) = 'ENDI') Or
       (Copy(str1, 1, 5) = 'ENDDO') Or
       (Copy(str1, 1, 5) = 'ENDIF') Then Begin
      If (TrimRight(str1) = 'NEXT') Or
         (TrimRight(str1) = 'ENDD') Or
         (TrimRight(str1) = 'ENDI') Or
         (TrimRight(str1) = 'ENDDO') Or
         (TrimRight(str1) = 'ENDIF') Then Begin
        setstring(h, TrimRight(str3) + '   //' + masstring[stek-1]);
      End;
      dec(stek);
    End;
    Inc(h);
  End; //for h=1 to kol_lines do
End;

//////////////////////////////////////////////////////////////////////////

Procedure CommentBlock;
Var str1: String;
Begin
  If is_block Then Begin
    h := beg_line_block;
    While h <= kol_lines Do Begin
      str1 := TrimLeft(get_str(h));
      If ((WAS.SelStart = was.SelEnd) Or (was.SelStart = -1)) Then Break;
      If Copy(str1, 1, 2) <> '//' Then Begin
        str1 := '//' + was.stringtext;
        setstring(h, str1);
      End;
      Inc(h);
    End; //H:=1 to kol_lines
  End
  Else Begin
    Message(FMSG_Warning, 'Contents',
      [Integer(MError), Integer(Mnoblockselected), Integer(Mok)], 1);
  End;
End;

//////////////////////////////////////////////////////////////////////////

Procedure UnCommentBlock;
Var str1: String;
  pui: Integer;
Begin
  If is_block Then Begin
    h := beg_line_block;
    While h <= kol_lines Do Begin
      str1 := get_str(h);
      If ((WAS.SelStart = was.SelEnd) Or (was.SelStart = -1)) Then Break;
      pui := pos('//', str1);
      If pui > 0 Then Begin
        Delete(str1, pui, 2);
        setstring(h, str1);
      End;
      Inc(h);
    End; //H:=1 to kol_lines
  End
  Else Begin
    Message(FMSG_Warning, 'Contents',
      [Integer(MError), Integer(Mnoblockselected), Integer(Mok)], 1);
  End;
End;

//////////////////////////////////////////////////////////////////////////

Procedure FunctionList;
Var stek: Integer;
  str1: String;
  masinteg: Array Of Integer;
  masstring: Array Of String;
  ItemsNumber: Integer;
  aItems: pFarMenuItemArr;
  h1, currentFunc: Integer;
  RestorePos: Boolean;
Begin
  h := 0;
  stek := 0;
  currentFunc := 0;
  RestorePos := False;
  While h <= kol_lines Do Begin
    str1 := AnsiUpperCase(TrimLeft(get_str(h)));
    If (Copy(str1, 1, 4) = 'PROC') Or (Copy(str1, 1, 9) = 'PROCEDURE') Or
      (Copy(str1, 1, 4) = 'FUNC') Or (Copy(str1, 1, 8) = 'FUNCTION') Then Begin
      SetLength(masinteg, stek+1);
      SetLength(masstring, stek+1);
      masinteg[stek] := h;
      Str(stek+1:2, masstring[stek]);
      masstring[stek]:=masstring[stek] + '. ' + was.stringtext;
      Inc(stek);
    End;
    If (h = ei.CurLine) Then currentFunc := stek;
    Inc(h);
  End;
  If stek = 0 Then Begin
    Message(0, 'Contents', [Integer(MWarning), Integer(Mnoproc), Integer(Mok)], 1);
    RestorePos := True;
  End
  Else Begin
    ItemsNumber := stek;
    GetMem(aItems, SizeOf(TFarMenuItem) * ItemsNumber);
    For h1 := 0 To ItemsNumber - 1 Do Begin
      With aItems^[h1] Do Begin
        strcopy(aitems[h1].Text, pChar(masstring[h1]));
        Checked := 0;
        Separator := 0;
        Selected := integer(h1 = CurrentFunc-1);
      End;
    End;
    h1 := info.menu(info.ModuleNumber, -1, -1, 0, FMENU_AUTOHIGHLIGHT,
      GetMsg(Mfunclist), Nil, 'Contents', Nil, Nil, aitems, itemsnumber);
    FreeMem(aItems);
    If h1 > -1 Then Begin
      with sp do begin
        CurTabPos := -1; Overtype := -1; LeftPos := -1;
        CurPos := 0; CurLine := masinteg[h1];
        TopScreenLine := CurLine;
      end;
      Info.EditorControl(ECTL_SETPOSITION, @sp);
      Info.EditorControl(ECTL_PROCESSKEY, pointer(KEY_CTRLSHIFTRIGHT));
      Info.EditorControl(ECTL_PROCESSKEY, pointer(KEY_CTRLRIGHT));
      with sp do begin
        CurPos:=-1; CurTabPos:=-1; CurLine:=-1; Overtype:=-1; TopScreenLine:=-1;
        LeftPos:=0;
      end;
      Info.EditorControl(ECTL_SETPOSITION, @sp);
    End
    Else
      RestorePos := True;
  End;
  If RestorePos Then Begin //   ( ,  ESC)
    sp.CurLine := ei.CurLine;
    sp.CurPos := ei.CurPos;
    sp.TopScreenLine := ei.TopScreenLine;
    sp.LeftPos := ei.LeftPos;
    Info.EditorControl(ECTL_SETPOSITION, @sp);
  End;

End;

//////////////////////////////////////////////////////////////////////////
procedure UpdateSample(hDlg: THandle);
var sample: TFarDialogItem;
    dialogrect:TSmallRect;
    ctab:TFarDialogItemData;
    x,y,e:integer;
    width:integer;
    _gtab,_mtab,_tab,_ftab,_tftab,_ctab,_sltab:integer;
const color=27;
begin
  Info.SendDlgMessage(hDlg,DM_GETDLGRECT,0,integer(@dialogrect));
  Info.SendDlgMessage(hDlg,DM_GETDLGITEM,19,integer(@sample));
  x:=dialogrect.Left+sample.X1+1;
  y:=dialogrect.Top+sample.Y1;
  width:=sample.X2-sample.X1+1;
  GetMem(ctab.PtrData, 20);

  Info.SendDlgMessage(hDlg,DM_GETTEXT,2,integer(@ctab));
  val(ctab.PtrData,_gtab,e); if (e>0) then _gtab:=0;
  Info.SendDlgMessage(hDlg,DM_GETTEXT,4,integer(@ctab));
  val(ctab.PtrData,_mtab,e); if (e>0) then _mtab:=0;
  Info.SendDlgMessage(hDlg,DM_GETTEXT,6,integer(@ctab));
  val(ctab.PtrData,_ftab,e); if (e>0) then _ftab:=0;
  Info.SendDlgMessage(hDlg,DM_GETTEXT,8,integer(@ctab));
  val(ctab.PtrData,_tftab,e); if (e>0) then _tftab:=0;
  Info.SendDlgMessage(hDlg,DM_GETTEXT,10,integer(@ctab));
  val(ctab.PtrData,_tab,e); if (e>0) then _tab:=0;
  Info.SendDlgMessage(hDlg,DM_GETTEXT,12,integer(@ctab));
  val(ctab.PtrData,_ctab,e); if (e>0) then _ctab:=0;
  Info.SendDlgMessage(hDlg,DM_GETTEXT,14,integer(@ctab));
  val(ctab.PtrData,_sltab,e); if (e>0) then _sltab:=0;

  if (_ctab>=0) then Info.Text(x,y-1,19,PChar(Copy(StringOfChar(' ',_ctab)+                  '// Sample program                       ',1,width)))
                else Info.Text(x,y-1,19,PChar(Copy(StringOfChar(' ',_mtab+_gtab)+            '// Sample program                       ',1,width)));
  Info.Text(x,y+0,color,PChar(Copy(StringOfChar(' ',_mtab+_gtab)+                            'Public var, arr                         ',1,width)));
  Info.Text(x,y+1,color,PChar(Copy(StringOfChar(' ',_mtab+_gtab)+                            'var:=500                                ',1,width)));
  Info.Text(x,y+2,color,PChar(Copy(StringOfChar(' ',_mtab+_gtab)+                            'arr:=fill(var)                          ',1,width)));
  Info.Text(x,y+3,color,PChar(Copy(StringOfChar(' ',_mtab+_gtab)+                            '                                        ',1,width)));
  Info.Text(x,y+4,color,PChar(Copy(StringOfChar(' ',_ftab+_gtab)+                            'Function fill(x)                        ',1,width)));
  Info.Text(x,y+5,color,PChar(Copy(StringOfChar(' ',_tftab+_gtab)+                           'Local rs                                ',1,width)));
  Info.Text(x,y+6,color,PChar(Copy(StringOfChar(' ',_tftab+_gtab)+                           'rs:={{2,5,1}, ;                         ',1,width)));
  if (_sltab>=0) then Info.Text(x,y+7,color,PChar(Copy(StringOfChar(' ',_tftab+_gtab+_sltab)+'{4,7,6}}                                ',1,width)))
                 else Info.Text(x,y+7,color,PChar(Copy(StringOfChar(' ',_tftab+_gtab+5)+     '{4,7,6}}                                ',1,width)));
  Info.Text(x,y+8,color,PChar(Copy(StringOfChar(' ',_tftab+_gtab)+                           'If (x>0)                                ',1,width)));
  if (_ctab>=0) then Info.Text(x,y+9,19,PChar(Copy(StringOfChar(' ',_ctab)+                  '/* x must be                            ',1,width)))
                else Info.Text(x,y+9,19,PChar(Copy(StringOfChar(' ',_tab+_tftab+_gtab)+      '/* x must be                            ',1,width)));
  if (_ctab>=0) then Info.Text(x,y+10,19,PChar(Copy(StringOfChar(' ',_ctab)+                 'positive */                             ',1,width)))
                else Info.Text(x,y+10,19,PChar(Copy(StringOfChar(' ',_tab+_tftab+_gtab)+     'positive */                             ',1,width)));
  Info.Text(x,y+11,color,PChar(Copy(StringOfChar(' ',_tab+_tftab+_gtab)+                     'AEval(rs, {|n| n[1]*=x})                ',1,width)));
  Info.Text(x,y+12,color,PChar(Copy(StringOfChar(' ',_tab+_tftab+_gtab)+                     'QOut("OK.")                             ',1,width)));
  Info.Text(x,y+13,color,PChar(Copy(StringOfChar(' ',_tftab+_gtab)+                          'Endif                                   ',1,width)));
  Info.Text(x,y+14,color,PChar(Copy(StringOfChar(' ',_tftab+_gtab)+                          'Return rs                               ',1,width)));
end;
//////////////////////////////////////////////////////////////////////////
function SettingsDlgProc(hDlg: THandle; Msg: integer; Param1: integer; Param2: integer): integer; stdcall;
var
  txt:   PFarDialogItemData;
  num,e: integer;
begin
  Result:=Info.DefDlgProc(hDlg, Msg, Param1, Param2);
  case Msg of
    DN_KILLFOCUS:
      if (Param1 in [2,4,6,8,10,12,14]) then begin
        GetMem(txt,SizeOf(txt^));
        GetMem(txt.PtrData, 20);
        Info.SendDlgMessage(hDlg,DM_GETTEXT,Param1,integer(txt));
        val(txt.PtrData,num,e);
        if (e>0) then num:=0;
        if (num<0) and (Param1 in [2,4,6,8,10]) then num:=0;
        StrCopy(txt.PtrData,PChar(IntToStr(num)));
        txt.PtrLength:=StrLen(txt.PtrData)+1;
        Info.SendDlgMessage(hDlg,DM_SETTEXT,Param1,integer(txt));
        FreeMem(txt.PtrData);
        FreeMem(txt);
        UpdateSample(hDlg);
        Result:=-1;
      end;
    DN_DRAWDLGITEM:
      if (Param1=19) then UpdateSample(hDlg);
  end;
end;

Function Settings(not_used: integer): integer;
var
  items: PFarDialogItemArr;
  pMyDlgProc: TFarApiWndProc;
  DialogResult: integer;
  cfg: PChar;
const
  itemsnum=20;
  initarray: packed array [0..itemsnum-1] of TInitDialogItem = (
  (ItemType:DI_DOUBLEBOX; X1: 0; Y1: 0; X2:74; Y2:19; Focus:0; Selected:0; Flags:0; DefaultButton:0; Data:PChar(MConfigTitle)),
  (ItemType:DI_TEXT;      X1: 2; Y1: 2; X2: 0; Y2: 0; Focus:0; Selected:0; Flags:0; DefaultButton:0; Data:PChar(MGlobalTab)),
  (ItemType:DI_FIXEDIT;   X1: 2; Y1: 3; X2: 3; Y2: 0; Focus:1; Selected:0; Flags:0; DefaultButton:0; Data:''),
  (ItemType:DI_TEXT;      X1: 2; Y1: 4; X2: 0; Y2: 0; Focus:0; Selected:0; Flags:0; DefaultButton:0; Data:PChar(MMainTab)),
  (ItemType:DI_FIXEDIT;   X1: 2; Y1: 5; X2: 3; Y2: 0; Focus:1; Selected:0; Flags:0; DefaultButton:0; Data:''),
  (ItemType:DI_TEXT;      X1: 2; Y1: 6; X2: 0; Y2: 0; Focus:0; Selected:0; Flags:0; DefaultButton:0; Data:PChar(MFuncTab)),
  (ItemType:DI_FIXEDIT;   X1: 2; Y1: 7; X2: 3; Y2: 0; Focus:1; Selected:0; Flags:0; DefaultButton:0; Data:''),
  (ItemType:DI_TEXT;      X1: 2; Y1: 8; X2: 0; Y2: 0; Focus:0; Selected:0; Flags:0; DefaultButton:0; Data:PChar(MTextFuncTab)),
  (ItemType:DI_FIXEDIT;   X1: 2; Y1: 9; X2: 3; Y2: 0; Focus:1; Selected:0; Flags:0; DefaultButton:0; Data:''),
  (ItemType:DI_TEXT;      X1: 2; Y1:10; X2: 0; Y2: 0; Focus:0; Selected:0; Flags:0; DefaultButton:0; Data:PChar(MTab)),
  (ItemType:DI_FIXEDIT;   X1: 2; Y1:11; X2: 3; Y2: 0; Focus:1; Selected:0; Flags:0; DefaultButton:0; Data:''),
  (ItemType:DI_TEXT;      X1: 2; Y1:12; X2: 0; Y2: 0; Focus:0; Selected:0; Flags:0; DefaultButton:0; Data:PChar(MComments)),
  (ItemType:DI_FIXEDIT;   X1: 2; Y1:13; X2: 3; Y2: 0; Focus:1; Selected:0; Flags:0; DefaultButton:0; Data:''),
  (ItemType:DI_TEXT;      X1: 2; Y1:14; X2: 0; Y2: 0; Focus:0; Selected:0; Flags:0; DefaultButton:0; Data:PChar(MNextStringTab)),
  (ItemType:DI_FIXEDIT;   X1: 2; Y1:15; X2: 3; Y2: 0; Focus:1; Selected:0; Flags:0; DefaultButton:0; Data:''),
  (ItemType:DI_TEXT;      X1: 0; Y1:17; X2: 0; Y2: 0; Focus:0; Selected:0; Flags:0; DefaultButton:0; Data:'Ķ'),
  (ItemType:DI_BUTTON;    X1: 2; Y1:18; X2: 0; Y2: 0; Focus:0; Selected:0; Flags:DIF_CENTERGROUP; DefaultButton:1; Data:PChar(MOK)),
  (ItemType:DI_BUTTON;    X1: 2; Y1:18; X2: 0; Y2: 0; Focus:0; Selected:0; Flags:DIF_CENTERGROUP; DefaultButton:0; Data:PChar(MCancel)),
  (ItemType:DI_VTEXT;     X1:37; Y1: 1; X2: 0; Y2: 0; Focus:0; Selected:0; Flags:0; DefaultButton:0; Data:''),
  (ItemType:DI_USERCONTROL; X1:38;Y1:2; X2:71; Y2:16; Focus:0; Selected:0;Flags:DIF_NOFOCUS+DIF_DISABLE; DefaultButton:0; Data:Nil)
  );
Begin
  Result:=0;
  pMyDlgProc:=SettingsDlgProc;
  initarray[ 2].Data:=PChar(IntToStr(globaltab));
  initarray[ 4].Data:=PChar(IntToStr(MAINTAB));
  initarray[ 6].Data:=PChar(IntToStr(FUNCTAB));
  initarray[ 8].Data:=PChar(IntToStr(TEXTFUNCTAB));
  initarray[10].Data:=PChar(IntToStr(atab));
  initarray[12].Data:=PChar(IntToStr(comments));
  initarray[14].Data:=PChar(IntToStr(tcns));
  GetMem(items, SizeOf(TFarDialogItem)*itemsnum);
  InitDialogItems(@initarray, items, itemsnum);
  DialogResult:=Info.DialogEx(Info.ModuleNumber, -1,-1,75,20,
                'Config', items, itemsnum, 0, 0, pMyDlgProc, 0);
  if (DialogResult=16) then begin //OK pressed
    globaltab:=StrToInt(items[2].Data);
    maintab:=StrToInt(items[4].Data);
    functab:=StrToInt(items[6].Data);
    textfunctab:=StrToInt(items[8].Data);
    atab:=StrToInt(items[10].Data);
    comments:=StrToInt(items[12].Data);
    tcns:=StrToInt(items[14].Data);
    //save it!
    GetMem(cfg,2048);
    StrCopy(cfg,PChar(tek_path+'setup\clstuff.ini'));
    WritePrivateProfileString('Settings','GlobalTab',PChar(IntToStr(globaltab)),cfg);
    WritePrivateProfileString('Settings','MainTab',PChar(IntToStr(maintab)),cfg);
    WritePrivateProfileString('Settings','Tab',PChar(IntToStr(atab)),cfg);
    WritePrivateProfileString('Settings','FuncTab',PChar(IntToStr(functab)),cfg);
    WritePrivateProfileString('Settings','TextFuncTab',PChar(IntToStr(textfunctab)),cfg);
    WritePrivateProfileString('Settings','Comments',PChar(IntToStr(comments)),cfg);
    WritePrivateProfileString('Settings','SplitLineTab',PChar(IntToStr(tcns)),cfg);
    FreeMem(cfg);
    Result:=1;
  end;
  FreeMem(items);
End;

//////////////////////////////////////////////////////////////////////////
Function ReadConfigFiles: Boolean;
var
  ftxt: TextFile;
  str1: String;
  cfg: PChar;
begin
  tek_path := ExtractFileDir(Info.ModuleName) +'\';
  //   
  assignfile(ftxt, tek_path + 'setup\Keywords.dat');
  reset(ftxt);
  audi := 0;
  While Not (EOF(ftxt)) Do Begin
    readln(ftxt, str1);
    If Length(str1) > 0 Then
      If str1[1] <> ';' Then begin
        SetLength(clipmas, audi+1);
        clipmas[audi] := str1;
        Inc(audi);
      end;
  End;
  closefile(ftxt);

  //   
  assignfile(ftxt, tek_path + 'setup\Replace.dat');
  reset(ftxt);
  Kozlovam := 0;
  While Not (EOF(ftxt)) Do Begin
    readln(ftxt, str1);
    If Length(str1) > 0 Then
      If str1[1] <> ';' Then begin
        SetLength(key_before, Kozlovam+1);
        SetLength(key_after, Kozlovam+1);
        key_before[Kozlovam] := AnsiUpperCase(TrimRight(Copy(str1, 1, 11)));
        key_after[Kozlovam] := Trim(Copy(str1, 12, Length(str1) - 11));
        Inc(Kozlovam);
      end;
  End;
  closefile(ftxt);

  //  
  GetMem(cfg,2048);
  StrCopy(cfg,PChar(tek_path+'setup\clstuff.ini'));
  globaltab:=  GetPrivateProfileInt('Settings','GlobalTab',0,cfg);
  maintab:=    GetPrivateProfileInt('Settings','MainTab',0,cfg);
  atab:=       GetPrivateProfileInt('Settings','Tab',2,cfg);
  functab:=    GetPrivateProfileInt('Settings','FuncTab',0,cfg);
  textfunctab:=GetPrivateProfileInt('Settings','TextFuncTab',2,cfg);
  comments:=   GetPrivateProfileInt('Settings','Comments',-1,cfg);
  tcns:=       GetPrivateProfileInt('Settings','SplitLineTab',-1,cfg);
  FreeMem(cfg);

  Result:=true;
end;
//////////////////////////////////////////////////////////////////////////
Function OpenPlugin(OpenFrom: integer; Item: integer): THandle
  Stdcall Export;
Var
  aItems: pFarMenuItemArr;
  str1: String;
  amessage: Integer;
  OneMoreMenu: Boolean;
const
  ItemsNumber=7;
Begin
  Info.EditorControl(ECTL_GETINFO, @ei);
  str1 := string(ei.filename);
  inden := Length(str1)+1;
  repeat Dec(inden) until (inden = 0) or (Copy(str1, inden, 1) = '.');
  str1 := Copy(str1, inden + 1, Length(str1) - inden);

  If (AnsiUpperCase(str1)<>'PRG')and(AnsiUpperCase(str1)<>'CH') Then
    Message(0, 'Contents', [Integer(MWarning), Integer(Mnotprg), Integer(MOK)], 1);
  repeat
    OneMoreMenu:=false;
    beg_line_block := 0;
    GetMem(aItems, SizeOf(TFarMenuItem)*ItemsNumber);
    ZeroMemory(aItems, SizeOf(TFarMenuItem)*ItemsNumber);

    StrECopy(StrECopy(aitems^[0].Text, '1. '), GetMsg(MFormat));
    StrECopy(StrECopy(aitems^[1].Text, '2. '), GetMsg(MFuncList));
    StrECopy(StrECopy(aitems^[2].Text, '3. '), GetMsg(MCommentBlock));
    StrECopy(StrECopy(aitems^[3].Text, '4. '), GetMsg(MUnCommentBlock));
    StrECopy(StrECopy(aitems^[4].Text, '5. '), GetMsg(MCommentEndOfLines));
    aitems[5].Separator := 1; // 
    StrECopy(StrECopy(aitems^[6].Text, '6. '), GetMsg(MConfig));

    amessage := info.menu(info.ModuleNumber, -1, -1, 0, FMENU_WRAPMODE Or FMENU_AUTOHIGHLIGHT,
      GetMsg(MPluginName), Nil, 'Contents', Nil, Nil, aitems, itemsnumber);
    FreeMem(aItems);

    kol_lines := ei.totallines;
    is_block := ((ei.BlockType = BTYPE_STREAM) Or (ei.BlockType = BTYPE_COLUMN));
    If is_block Then
      beg_line_block := ei.BlockStartLine;

    was.StringNumber := -1;
    sp.CurPos := -1;
    sp.CurTabPos := -1;
    sp.TopScreenLine := -1;
    sp.LeftPos := -1;
    sp.Overtype := -1;

    ////////////////////////////////////////////////////
    Case amessage Of
      0: Capitalization;
      1: FunctionList;
      2: CommentBlock;
      3: UnCommentBlock;
      4: CommentEndOperator;
      5: {Separator};
      6: Settings(0);
    End;
    ////////////////////////////////////////////////////

    case amessage of
      1: ;
      6: OneMoreMenu:=true;
      else begin
        sp.CurLine := ei.CurLine;
        sp.CurPos := ei.CurPos;
        sp.TopScreenLine := ei.TopScreenLine;
        sp.LeftPos := ei.LeftPos;
        Info.EditorControl(ECTL_SETPOSITION, @sp);
      end;
    end;
  until not OneMoreMenu;
  Result := INVALID_HANDLE_VALUE;
End;

Procedure GetPluginInfo(Var Info: TPluginInfo); Stdcall Export;
Begin
  With Info Do Begin
    StructSize := SizeOf(Info);
    Flags := PF_EDITOR+PF_DISABLEPANELS;
    DiskMenuStringsNumber := 0;
    PluginStrings[0] := GetMsg(MPluginName);
    PluginMenuStrings := @PluginStrings;
    PluginMenuStringsNumber := 1;
    PluginConfigStringsNumber := 1;
    PluginConfigStrings := @PluginStrings;
    CommandPrefix := Nil;
  End;
End;

procedure SetStartupInfo(var AInfo: TPluginStartupInfo)
  stdcall export;
begin
  Info := AInfo;
  ReadConfigFiles;
end;

function GetMinFarVersion: integer; stdcall; export;
begin
  Result:=FARMANAGERVERSION;
end;

Exports
  OpenPlugin, GetPluginInfo, SetStartupInfo, GetMinFarVersion, Settings name 'Configure';
Begin
End.

